//#include <mega32.h>
static char screenpos[4][20] = {
                                {0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,
                                 0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,0x90,0x91,0x92,0x93},
                                {0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,
                                 0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,0xD0,0xD1,0xD2,0xD3},
                                {0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,
                                 0x9E,0x9F,0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7},
                                {0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,
                                 0xDE,0xDF,0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7}
                               };  

void temp()
{ 
 int t;
   //switch the LCD off 
  WritePortD(0x00,0x10);//0xx
  //wrting 0 lines
  WritePortA(0x00,0xFF);//data=0
  SetPortA_In(0xFF);//set port A as input
  //configure  LCD_read command
  WritePortD(0x20,0x70);//010//reading configuration

 for(t=0;t<50;t++);//timing
  WritePortD(0x10,0x10);//1xx
  // //activating LCD
  //  MA_WritePort_IO(MA_PORTG,0x00,0x04);
  ///////////////////////////////////////////////////debugbuton

//do{
 //citire busy flag
 //t=PINA;
 //}while(t&0x80);
 //MA_WritePort_IO(MA_PORTE,0xFF,0xFF);//data
 WritePortD(0x00,0x10);//000
 for(t=0;t<50;t++);//timing
  WritePortD(0x00,0x70);//000
  SetPortD_In(0x70);//set specific bits of port D as input
}

void send_command (const char s)
{ int temp_g;

  
  PORTD=0x00;  //000
  DDRA=0xFF;//set port A as Output
  DDRD=0xFF;//set port D sd Output

  PORTA=s;//command
  PORTD=0x10;  //100
  for(temp_g=0;temp_g<50;temp_g++);//timing
  //temp();
}

void send_char (const char s)
{   
  int t;
  //temp();
  WritePortD(0x00,0x70);  //000
  SetPortA_Out(0xFF);//set specific bits of port A as Output
  SetPortD_Out(0x70);//set specific bits of port D as Onput

  WritePortA(s,0xFF);//data
  WritePortD(0x50,0x70);  //101 write data   
  
  for(t=0;t<50;t++);//timing
  temp(); 
}

void init()
{
//init_LCD();
  int temp_g;
  int ig;
  //read from LCD
  DDRA=0xFF;//set Port A as Output
  DDRD=0xFF;//set Port D as Output
  //MA_WritePort_IO(MA_PORTG,0x00,0x07);  //000

  PORTD=0x10; //E=1 enable
  for(temp_g=0;temp_g<200;temp_g++);//timing

  //temp();
  for(ig=0;ig<3;ig++)
  {
   send_command(0x3c);//function Set : 8bits 2line on
   for(temp_g=0;temp_g<200;temp_g++);//timing
  }
   send_command(0x0F);//Display on
   for(temp_g=0;temp_g<200;temp_g++);//timing

   send_command(0x01);//Display clear
   for(temp_g=0;temp_g<200;temp_g++);//timing

   send_command(0x06);//Entry mode select
   for(temp_g=0;temp_g<200;temp_g++);//timing

 //  MA_WritePort_IO(MA_PORTE,0xFF,0xFF);//data

  // send_command(0x0f);//Display on
   //for(temp_g=0;temp_g<200;temp_g++);//timing
   usart_init();
//End of initialization
}   

void send_string (char *str) {			// sends the whole string to LCD
 while ((*str != 0)&& (*str != 10))
   send_char (*str++);
}

void setpos (char x,char y) {
 send_command (screenpos[x-1][y-1]);
}  
