//variable declaration extern - global.c
extern unsigned char t_sph;
extern unsigned char t_spl;
extern unsigned char t_r29;
extern unsigned char t_r28;
extern unsigned char task_time;
extern unsigned int global_inc_g;
extern unsigned int global_inc;


//interrupt service routine
//ADD THIS CODE TO TIMER INTERRUPT SERVICE ROUTINE!!!
//__interrupt   ISR_OVR_TIMER(void)
{
//disable interrupt
  __disable_interrupt();

//save registers using Y pointer
  asm("ST      -Y,R27");
  asm("ST      -Y,R26");
  asm("ST      -Y,R25");
  asm("ST      -Y,R24");
  asm("ST      -Y,R31");
  asm("ST      -Y,R30");
  asm("ST      -Y,R3");
  asm("ST      -Y,R2");
  asm("ST      -Y,R1");
  asm("ST      -Y,R0");
  asm("ST      -Y,R23");
  asm("ST      -Y,R22");
  asm("ST      -Y,R21");
  asm("ST      -Y,R20");
  asm("ST      -Y,R19");
  asm("ST      -Y,R18");
  asm("ST      -Y,R17");
  asm("ST      -Y,R16");
  asm("IN      R26,0x3F");
  asm("IN      R27,0x3B");
  asm("  ST -Y, R4");
  asm("  ST -Y, R5");
  asm("  ST -Y, R6");
  asm("  ST -Y, R7");
  asm("  ST -Y, R8");
  asm("  ST -Y, R9");
  asm("  ST -Y, R10");
  asm("  ST -Y, R11");
  asm("  ST -Y, R12");
  asm("  ST -Y, R13");
  asm("  ST -Y, R14");
  asm("  ST -Y, R15");
  asm("  ST -Y, R26");

  global_inc++;//increment interrupt counter variable for time expire task switching
  global_inc_g++;//increment time counter for delay function


//test time expire
  if(b_start_so)//only if start OS
   {
   if(global_inc>=(task_time*TICK_TIME))//if time period for current task expire
   {
//init interrupt counter variable
    global_inc=0;
//init t_sp and t_r variables
    t_sph=0;
    t_spl=0;
    t_r29=0;
    t_r28=0;
    get_tsp();//

//save Y pointer for current task
    asm("  LDS R30,t_r28");//R26 <- t_r28
    asm("  LDS R31,t_r29");//R27 <- t_r29
    asm("  ST -Z, R28");//salvare pointer Y
    asm("  ST -Z, R29");

//save stack pointer for current task
    asm("  LDS R30,t_spl");//stack pointer is saved using Y pointer already saved
    asm("  LDS R31,t_sph");
    asm("  IN R16,0x3d");//save SPH
    asm("  ST -Z,R16");
    asm("  IN R16,0x3e");//save SPL
    asm("  ST -Z,R16");


    push_var();//save global variables
    comuta_task();//task switching
    pop_var();//restore global variables for new current task

//restore stack pointer for new current task
  asm("  LDS R28,t_spl");
  asm("  LDS R29,t_sph");
  asm("  LD R16,-Y");
  asm("  OUT 0x3d,R16");
  asm("  LD R16,-Y");
  asm("  OUT 0x3e,R16");

//restore Y pointer for new current task
  asm("  LDS R30,t_r28");
  asm("  LDS R31,t_r29");
  asm("  LD R28,-Z");
  asm("  LD R29,-Z");

   }

  }

 //restore all registers
  asm("  LD R26,Y+");
  asm("  LD R15,Y+");
  asm("  LD R14,Y+");
  asm("  LD R13,Y+");
  asm("  LD R12,Y+");
  asm("  LD R11,Y+");
  asm("  LD R10,Y+");
  asm("  LD R9,Y+");
  asm("  LD R8,Y+");
  asm("  LD R7,Y+");
  asm("  LD R6,Y+");
  asm("  LD R5,Y+");
  asm("  LD R4,Y+");

  asm("OUT     0x3B,R27");
  asm("OUT     0x3F,R26");
  asm("LD      R16,Y+");
  asm("LD      R17,Y+");
  asm("LD      R18,Y+");
  asm("LD      R19,Y+");
  asm("LD      R20,Y+");
  asm("LD      R21,Y+");
  asm("LD      R22,Y+");
  asm("LD      R23,Y+");
  asm("LD      R0,Y+");
  asm("LD      R1,Y+");
  asm("LD      R2,Y+");
  asm("LD      R3,Y+");
  asm("LD      R30,Y+");
  asm("LD      R31,Y+");
  asm("LD      R24,Y+");
  asm("LD      R25,Y+");
  asm("LD      R26,Y+");
  asm("LD      R27,Y+");

//enable interrupt
   __enable_interrupt();
//when return restart function for current task
}
