

//Includedateien (spter: AVR studio dir)
#include<avr/io.h>
#include"global.c"//globale Variablendeklaration
#include"my_os.c"//Betriebssystemkernel
#include<avr/interrupt.h>

//globale Parameter_Akkus

register bool akku asm("r3");
register char realakku asm("r2");
register int intakku asm("r4");
unsigned int ref;



void increment_ms(void)
{
_delay_ms(1);
//sichere die Register durch Y pointer
  asm("ST      -Y,R27");
  asm("ST      -Y,R26");
  asm("ST      -Y,R25");
  asm("ST      -Y,R24");
  asm("ST      -Y,R31");
  asm("ST      -Y,R30");
  asm("ST      -Y,R3");
  asm("ST      -Y,R2");
  asm("ST      -Y,R1");
  asm("ST      -Y,R0");
  asm("ST      -Y,R23");
  asm("ST      -Y,R22");
  asm("ST      -Y,R21");
  asm("ST      -Y,R20");
  asm("ST      -Y,R19");
  asm("ST      -Y,R18");
  asm("ST      -Y,R17");
  asm("ST      -Y,R16");
  asm("IN      R26,0x3F");
  asm("IN      R27,0x3B");
  asm("  ST -Y, R4");
  asm("  ST -Y, R5");
  asm("  ST -Y, R6");
  asm("  ST -Y, R7");
  asm("  ST -Y, R8");
  asm("  ST -Y, R9");
  asm("  ST -Y, R10");
  asm("  ST -Y, R11");
  asm("  ST -Y, R12");
  asm("  ST -Y, R13");
  asm("  ST -Y, R14");
  asm("  ST -Y, R15");
  asm("  ST -Y, R26");

  global_inc++;//Inkrementationsvariable fr Zeitablauf->Task gewechselt
  global_inc_g++;//Inkrementationsvariable fr Verzgerungsfunktion



//berprfe auf Zeitablauf
  if(b_start_so)//nur falls Betriebssystem gestartet
   {
   if(global_inc>=(200))//prfe ob Zeit abgelaufen
   {
//Setze Zeitablaufinkrementationsvariable zurck
    global_inc=0;
	
//initialisiere t_sp und t_r Variablen
    t_sph=0;
    t_spl=0;
    t_r29=0;
    t_r28=0;
    get_tsp();//

//speichere Y pointer fr den aktuellen Task
    asm("  LDS R30,t_r28");//R26 <- t_r28
    asm("  LDS R31,t_r29");//R27 <- t_r29
    asm("  ST -Z, R28");//sichere pointer Y
    asm("  ST -Z, R29");

//speichere stack pointer fr den aktuellen Task
    asm("  LDS R30,t_spl");//stack pointer is gesichert durch das verwenden von Y-Pointer
    asm("  LDS R31,t_sph");
    asm("  IN R16,0x3d");//sichere SPH
    asm("  ST -Z,R16");
    asm("  IN R16,0x3e");//sichere SPL
    asm("  ST -Z,R16");


    push_var();//sichere globale Variablen
    comuta_task();//wechsle Task
    pop_var();//wiederherstellen der globalen Variablen fr den aktuellen Tasj

//wiederherstellen des Stack pointers fr den neuen aktuellen Task
  asm("  LDS R28,t_spl");
  asm("  LDS R29,t_sph");
  asm("  LD R16,-Y");
  asm("  OUT 0x3d,R16");
  asm("  LD R16,-Y");
  asm("  OUT 0x3e,R16");

//wiederherstellen des Y Pointers fr den neuen aktuellen Task
  asm("  LDS R30,t_r28");
  asm("  LDS R31,t_r29");
  asm("  LD R28,-Z");
  asm("  LD R29,-Z");

   }

  }

 //wiederherstellen aller Register
  asm("  LD R26,Y+");
  asm("  LD R15,Y+");
  asm("  LD R14,Y+");
  asm("  LD R13,Y+");
  asm("  LD R12,Y+");
  asm("  LD R11,Y+");
  asm("  LD R10,Y+");
  asm("  LD R9,Y+");
  asm("  LD R8,Y+");
  asm("  LD R7,Y+");
  asm("  LD R6,Y+");
  asm("  LD R5,Y+");
  asm("  LD R4,Y+");

  asm("OUT     0x3B,R27");
  asm("OUT     0x3F,R26");
  asm("LD      R16,Y+");
  asm("LD      R17,Y+");
  asm("LD      R18,Y+");
  asm("LD      R19,Y+");
  asm("LD      R20,Y+");
  asm("LD      R21,Y+");
  asm("LD      R22,Y+");
  asm("LD      R23,Y+");
  asm("LD      R0,Y+");
  asm("LD      R1,Y+");
  asm("LD      R2,Y+");
  asm("LD      R3,Y+");
  asm("LD      R30,Y+");
  asm("LD      R31,Y+");
  asm("LD      R24,Y+");
  asm("LD      R25,Y+");
  asm("LD      R26,Y+");
  asm("LD      R27,Y+");
 
 

}


void ftask1(void)
{ 

bool a;
PORTC=0x00;
 
 
  for(;;){

PORTB=0x01;
increment_ms();


  };
}


void ftask2(void)
{

for(;;){PORTB=0x02;
increment_ms();

  		};
}


void ftask3(void)
{
 
  for(;;){PORTB=0x03;
  		  };
  
}


void ftask4(void)
{ 
for(;;){
PORTB=0x04;
};
} 

// globale Variablen hier deklarieren

void main(void)
{
init_hardware();

// lokale Variablen hier deklarieren


global_inc=0;
 b_start_so=0;

// erlaube global Interrupts
asm("sei"); 
global_inc=0;
start_so();//startet das Betriebssystem  (Kernel)

 creaza_task(ftask1,1);
 creaza_task(ftask2,1);
 creaza_task(ftask3,1);
 creaza_task(ftask4,1);
 
 
//initialisiere 1.Task
 init_task();
 pop_var();
 PopSP(); 
 //while(1){};
}




			



