
#include <avr/io.h>
#include "porturi.h" 
#include "functii_lcd.h"
#include "my_os.h"
#include "avr/interrupt.h"   

unsigned char i=0;
unsigned int global_inc;
unsigned int global_inc_g;
unsigned char b_start_so;
signed char lcd_sem;
unsigned char ig,jg,kg,lg,mg,ng,temp_g;
unsigned char schimba;
int led;
int b;
unsigned char aux;
unsigned int tem; 
signed char task_curent;
signed char task_coada;
signed char task_varf;
task rtos[NR_MAX_TASK];
unsigned char t_sph;
unsigned char t_spl;
unsigned char t_r29;
unsigned char t_r28;
unsigned char task_time;
unsigned int inc=0;  
char *pChar;

// Timer 0 overflow interrupt service routine
//interrupt [TIM0_OVF] void timer0_ovf_isr(void)
ISR(SIG_OVERFLOW1)

{
 
__disable_interrupt();

//save registers using Y pointer
  asm("ST      -Y,R27");
  asm("ST      -Y,R26");
  asm("ST      -Y,R25");
  asm("ST      -Y,R24");
  asm("ST      -Y,R31");
  asm("ST      -Y,R30");
  asm("ST      -Y,R3");
  asm("ST      -Y,R2");
  asm("ST      -Y,R1");
  asm("ST      -Y,R0");
  asm("ST      -Y,R23");
  asm("ST      -Y,R22");
  asm("ST      -Y,R21");
  asm("ST      -Y,R20");
  asm("ST      -Y,R19");
  asm("ST      -Y,R18");
  asm("ST      -Y,R17");
  asm("ST      -Y,R16");
  asm("IN      R26,0x3F");
  asm("IN      R27,0x3B");
  asm("  ST -Y, R4");
  asm("  ST -Y, R5");
  asm("  ST -Y, R6");
  asm("  ST -Y, R7");
  asm("  ST -Y, R8");
  asm("  ST -Y, R9");
  asm("  ST -Y, R10");
  asm("  ST -Y, R11");
  asm("  ST -Y, R12");
  asm("  ST -Y, R13");
  asm("  ST -Y, R14");
  asm("  ST -Y, R15");
  asm("  ST -Y, R26");

  global_inc++;//increment interrupt counter variable for time expire task switching
  global_inc_g++;//increment time counter for delay function


//test time expire
  if(b_start_so)//only if start OS
   {
   if(global_inc>=(task_time*TICK_TIME))//if time period for current task expire
   {
//init interrupt counter variable
    global_inc=0;
//init t_sp and t_r variables
    t_sph=0;
    t_spl=0;
    t_r29=0;
    t_r28=0;
    get_tsp();//

//save Y pointer for current task
    asm("  LDS R30,t_r28");//R26 <- t_r28
    asm("  LDS R31,t_r29");//R27 <- t_r29
    asm("  ST -Z, R28");//salvare pointer Y
    asm("  ST -Z, R29");

//save stack pointer for current task
    asm("  LDS R30,t_spl");//stack pointer is saved using Y pointer already saved
    asm("  LDS R31,t_sph");
    asm("  IN R16,0x3d");//save SPH
    asm("  ST -Z,R16");
    asm("  IN R16,0x3e");//save SPL
    asm("  ST -Z,R16");


    push_var();//save global variables
    comuta_task();//task switching
    pop_var();//restore global variables for new current task

//restore stack pointer for new current task
  asm("  LDS R28,t_spl");
  asm("  LDS R29,t_sph");
  asm("  LD R16,-Y");
  asm("  OUT 0x3d,R16");
  asm("  LD R16,-Y");
  asm("  OUT 0x3e,R16");

//restore Y pointer for new current task
  asm("  LDS R30,t_r28");
  asm("  LDS R31,t_r29");
  asm("  LD R28,-Z");
  asm("  LD R29,-Z");

   }

  }

 //restore all registers
  asm("  LD R26,Y+");
  asm("  LD R15,Y+");
  asm("  LD R14,Y+");
  asm("  LD R13,Y+");
  asm("  LD R12,Y+");
  asm("  LD R11,Y+");
  asm("  LD R10,Y+");
  asm("  LD R9,Y+");
  asm("  LD R8,Y+");
  asm("  LD R7,Y+");
  asm("  LD R6,Y+");
  asm("  LD R5,Y+");
  asm("  LD R4,Y+");

  asm("OUT     0x3B,R27");
  asm("OUT     0x3F,R26");
  asm("LD      R16,Y+");
  asm("LD      R17,Y+");
  asm("LD      R18,Y+");
  asm("LD      R19,Y+");
  asm("LD      R20,Y+");
  asm("LD      R21,Y+");
  asm("LD      R22,Y+");
  asm("LD      R23,Y+");
  asm("LD      R0,Y+");
  asm("LD      R1,Y+");
  asm("LD      R2,Y+");
  asm("LD      R3,Y+");
  asm("LD      R30,Y+");
  asm("LD      R31,Y+");
  asm("LD      R24,Y+");
  asm("LD      R25,Y+");
  asm("LD      R26,Y+");
  asm("LD      R27,Y+");

//enable interrupt
   __enable_interrupt();
//when return restart function for current task



// Place your code here
 

}
void delay(int t)
{
  do{
  }
  while(i<t); 
  i=0;
}                                

// Declare your global variables here

void ftask1(void)
{  
  for(;;){PORTB=0x01;
  //send_char('z');
  //send_char('z');
//MA_SetPortOut_IO(MA_PORTF,0xFF);
//MA_WritePort_IO(MA_PORTF,0xFF,0xFF);
  }
}

void ftask2(void)
{
for(;;){PORTB=0x02;
//send_char('y');
  while((b&0x08)==0x08){
  b=PINC;
  if((b&0x08)==0x00) delay(2);
  }
  while((b&0x08)==0x00){
  b=PINC;
  if((b&0x08)==0x08) delay(2);
  }
  led=~led;
  PORTB=led;
  if(aux==0) aux=1;
  else aux=0;
  schimba=1;
}
}

void ftask3(void)
{
   
  //if(aux==0)send_string(text1);
  //else send_string(text2);
  for(;;){PORTB=0x04;
  //send_char('x');
  if(schimba==1){ 
    if(aux==0)send_char('a');
    else send_char('b');
    schimba=0;
    //if(aux==0)send_string(text1);
    //else send_string(text2);
  }
  }
}

void ftask4(void)
{   
for(;;){PORTB=0x08;
        if( UCSRA & 0x80 ){
       *pChar = UDR; 
UDR = *pChar; }
};
} 
// Declare your global variables here

void main(void)
{
// Declare your local variables here
char *text1 = " Valy  ********abcdef";
// Input/Output Ports initialization
// Port A initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTA=0x00;
DDRA=0xFF;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTD=0x00;
DDRD=0xFF;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 62.500 kHz
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x04;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00; 
 
// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 9600 (Double Speed Mode)
UCSRA=0x02;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0xCF;

SetPortB_Out(0xFF );
SetPortC_In(0xFF );
SetPortD_Out(0xFF);
WritePortD(0x80,0x00);

init(); 
//setpos(2,2); 
//send_char('a'); 
//delay(100);
send_string(text1);
global_inc=0;
 b_start_so=0;
 aux=1;
 schimba=1;
UDR=0x41;
// Global enable interrupts
asm("sei"); 
global_inc=0;
start_so();//porneste sistemul de operare (kernelul)

 creaza_task(ftask1,10);
 creaza_task(ftask2,100);
 creaza_task(ftask3,100);
 creaza_task(ftask4,10);
//initializeaza primul task
 init_task();
 pop_var();
 PopSP(); 
}
//#include "my_os.h"
//#include <mega128.h>
//#include "global.h"
#include <stdlib.h>
//#include <inavr.h>

//externe
extern unsigned char t_sph;
extern unsigned char t_spl;
extern unsigned char t_r29;
extern unsigned char t_r28;
extern unsigned char task_time;
extern unsigned char ig,jg,kg,lg,mg,ng;
extern unsigned int global_inc_g;
extern unsigned int global_inc;
extern unsigned int inc;
extern unsigned char temp_g;
extern unsigned char b_start_so;
//extern S8 lcd_sem;
extern unsigned char lcd_coada[NR_MAX_TASK];


//folosita pentru initializarea t_sp si t_r in rutina timer
void get_tsp(void)
{
//initializare stiva (unde se gaseste adresa stivei)
    tem = (unsigned int) ((rtos[task_curent].adr_task)+OSTaskStkSize)>>8;
    t_sph=(unsigned char)(tem&0x00ff);
    t_spl=(unsigned char)((rtos[task_curent].adr_task)+OSTaskStkSize)&0xff;
//initializarea adresa pointer y
    tem = (unsigned int) ((rtos[task_curent].adr_task)+OSTaskStkSize-2)>>8;
    t_r29=(unsigned char)(tem&0x00ff);
    t_r28=(unsigned char)((rtos[task_curent].adr_task)+OSTaskStkSize-2)&0xff;
}

//salvarea variabilelor globale
void push_var(void)
{
//unsigned char ig,jg,kg,lg,mg,ng;
  rtos[task_curent].adr_task[OSTaskStkSize-5]=ig;
  rtos[task_curent].adr_task[OSTaskStkSize-6]=jg;
  rtos[task_curent].adr_task[OSTaskStkSize-7]=kg;
  rtos[task_curent].adr_task[OSTaskStkSize-8]=lg;
  rtos[task_curent].adr_task[OSTaskStkSize-9]=mg;
  rtos[task_curent].adr_task[OSTaskStkSize-10]=ng;
//  rtos[task_curent].adr_task[OSTaskStkSize-11]=(unsigned char)(global_inc_g&0x0ff);
//  rtos[task_curent].adr_task[OSTaskStkSize-12]=(unsigned char)((global_inc_g>>8)&0x0ff);

  rtos[task_curent].adr_task[OSTaskStkSize-11]=temp_g;
 // rtos[task_curent].adr_task[OSTaskStkSize-12]=init_t;
}
unsigned char comuta_task(void)
{
    if(task_varf==-1)//test daca este goala lista
      return 0;
//nou: task-ul este comutat numai daca este activat!
    do
    {
     if(task_curent>=task_coada)
       task_curent=task_varf-1;
     task_curent++;
     tem++;
    }while(!(rtos[task_curent].activ));
    task_time=rtos[task_curent].nr_timpi;
//initializare stiva (unde se gaseste adresa stivei)
    tem = (unsigned int) ((rtos[task_curent].adr_task)+OSTaskStkSize)>>8;
    t_sph=(unsigned char)(tem&0x00ff);
    t_spl=(unsigned char)((rtos[task_curent].adr_task)+OSTaskStkSize)&0xff;
//initializarea pointer y (unde se gaseste adresa registrilor r29 si r28)
    tem = (unsigned int) ((rtos[task_curent].adr_task)+OSTaskStkSize-2)>>8;
    t_r29=(unsigned char)(tem&0x00ff);
    t_r28=(unsigned char)((rtos[task_curent].adr_task)+OSTaskStkSize-2)&0xff;

    return 1;
} 

 //restaurarea noilor variabile locale
void pop_var(void)
{
  ig=rtos[task_curent].adr_task[OSTaskStkSize-5];
  jg=rtos[task_curent].adr_task[OSTaskStkSize-6];
  kg=rtos[task_curent].adr_task[OSTaskStkSize-7];
  lg=rtos[task_curent].adr_task[OSTaskStkSize-8];
  mg=rtos[task_curent].adr_task[OSTaskStkSize-9];
  ng=rtos[task_curent].adr_task[OSTaskStkSize-10];
  temp_g=rtos[task_curent].adr_task[OSTaskStkSize-11];
}  
  
void start_so(void)
{
 //initializeaza vectorul de taskuri
  task_varf=task_coada=task_curent=-1;//initializeaza index vector taskuri
}     

//functia creaza un task
unsigned char creaza_task(void (*taskf)(void),unsigned char numar)
{
    unsigned int i;
//1.pozitionarea taskului in lista
    if(task_varf==-1)//daca lista este vida
    {
      if(task_coada>=NR_MAX_TASK-1)//daca indexul nu este mai mare decat numarul de task-uri
        return T_EROARE;
      task_coada++;//incrementeaza indexul coada
      task_curent=task_varf=task_coada;
//initializare
    }
    else//daca lista are cel putin un element
    {
      if(task_coada>=NR_MAX_TASK-1)
        return 0;
      task_coada++;
    }
    rtos[task_coada].nr_timpi=numar;//initializare timpi task
    rtos[task_coada].activ=1;//initializare task on/off
    for(i=0;i<OSTaskStkSize;i++)
      rtos[task_coada].adr_task[i]=(unsigned char)i;//initializare stiva in total
//salvarea pointer functie
    i = (unsigned int) taskf;
    rtos[task_coada].adr_task[OSTaskStkSizeHard-1]=(unsigned char)i&0x0ff;//ocmps functie
    rtos[task_coada].adr_task[OSTaskStkSizeHard-2]=(unsigned char)((i>>8)&0x0ff);//ocms functie
//initializarea stivei
    i = (unsigned int) rtos[task_coada].adr_task+OSTaskStkSizeHard-3;
    rtos[task_coada].adr_task[OSTaskStkSize-1]=(unsigned char)i&0xff;
    rtos[task_coada].adr_task[OSTaskStkSize-2]=(unsigned char)(i>>8)&0xff;
//initialiarea pointer y
    i = (unsigned int) rtos[task_coada].adr_task+62;
    rtos[task_coada].adr_task[OSTaskStkSize-3]=(unsigned char)i&0xff;
    rtos[task_coada].adr_task[OSTaskStkSize-4]=(unsigned char)(i>>8)&0xff;

    return 1;
} 
  

//folosita pentru initializarea t_sp si t_r pentru primul task care se va executa
void init_task(void)
{
 //initializare stiva (unde se gaseste adresa stivei)
    task_time=rtos[task_curent].nr_timpi;
    tem = (unsigned int) ((rtos[task_curent].adr_task)+OSTaskStkSize)>>8;
    t_sph=(unsigned char)(tem&0x00ff);
    t_spl=(unsigned char)((rtos[task_curent].adr_task)+OSTaskStkSize)&0xff;
//initializarea pointer y
    tem = (unsigned int) ((rtos[task_curent].adr_task)+OSTaskStkSize-2)>>8;
    t_r29=(unsigned char)(tem&0x00ff);
    t_r28=(unsigned char)((rtos[task_curent].adr_task)+OSTaskStkSize-2)&0xff;
//initialiarea pointer y - la primul task stiva software este pregatita pentru incarcare valori registrii!
    tem = (unsigned int) rtos[task_curent].adr_task+80;
    rtos[task_curent].adr_task[OSTaskStkSize-3]=(unsigned char)tem&0xff;
    rtos[task_curent].adr_task[OSTaskStkSize-4]=(unsigned char)(tem>>8)&0xff;
}  

void PopSP(void)
{
  asm("cli");
  asm("  LDS R29,_t_sph");
  asm("  LDS R28,_t_spl");
  asm("  LD R16,-Y");
  asm("  OUT 0x3d,R16");
  asm("  LD R16,-Y");
  asm("  OUT 0x3e,R16");

//in plus setare pointer y pentru stiva soft!
  asm("  LDS R30,_t_r28");
  asm("  LDS R31,_t_r29");
  asm("  LD R28,-Z");
  asm("  LD R29,-Z");

  b_start_so=1;
  asm("sei");
}
#include "porturi.h" 
#include<avr/io.h>
SetPortA_Out(unsigned char BitMask )
{ 
        SetBit( DDRA, BitMask );      
} 
SetPortA_In(unsigned char BitMask )
{ 
        ClrBit( DDRA, BitMask );    
} 
WritePortA(unsigned char Value, unsigned char BitMask )
{
        PORTA &= Value | ~BitMask;
        PORTA |= Value & BitMask;
}
SetPortB_Out(unsigned char BitMask )
{ 
        SetBit( DDRB, BitMask );      
} 
SetPortB_In(unsigned char BitMask )
{ 
        ClrBit( DDRB, BitMask );    
} 
WritePortB(unsigned char Value, unsigned char BitMask )
{
        PORTB &= Value | ~BitMask;
        PORTB |= Value & BitMask;
} 
SetPortC_Out(unsigned char BitMask )
{ 
        SetBit( DDRC, BitMask );      
} 
SetPortC_In(unsigned char BitMask )
{ 
        ClrBit( DDRC, BitMask );    
} 
WritePortC(unsigned char Value, unsigned char BitMask )
{
        PORTC &= Value | ~BitMask;
        PORTC |= Value & BitMask;
}
SetPortD_Out(unsigned char BitMask )
{ 
        SetBit( DDRD, BitMask );      
} 
SetPortD_In(unsigned char BitMask )
{ 
        ClrBit( DDRD, BitMask );    
} 
WritePortD(unsigned char Value, unsigned char BitMask )
{
        PORTD &= Value | ~BitMask;
        PORTD |= Value & BitMask;
}
#include <avr/io.h>
static char screenpos[4][20] = {
                                {0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,
                                 0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,0x90,0x91,0x92,0x93},
                                {0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,
                                 0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,0xD0,0xD1,0xD2,0xD3},
                                {0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,
                                 0x9E,0x9F,0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7},
                                {0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,
                                 0xDE,0xDF,0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7}
                               };  

void temp()
{ 
 int t;
   //dezactivare LCD
  WritePortD(0x00,0x10);//0xx
  //scriere 0 linii
  WritePortA(0x00,0xFF);//data=0
  SetPortA_In(0xFF);//setare port A intrare
  //configurare citire LCD comanda
  WritePortD(0x20,0x70);//010//configurare citire

 for(t=0;t<50;t++);//temporizare
  WritePortD(0x10,0x10);//1xx
  // //activare LCD
  //  MA_WritePort_IO(MA_PORTG,0x00,0x04);
  ///////////////////////////////////////////////////debugbuton

//do{
 //citire busy flag
 //t=PINA;
 //}while(t&0x80);
 //MA_WritePort_IO(MA_PORTE,0xFF,0xFF);//data
 WritePortD(0x00,0x10);//000
 for(t=0;t<50;t++);//temporizare
  WritePortD(0x00,0x70);//000
  SetPortD_In(0x70);//setare port intrare
}

void send_command (const char s)
{ int temp_g;

  
  PORTD=0x00;  //000
  DDRA=0xFF;//setare port A iesire
  DDRD=0xFF;//setare port G iesire

  PORTA=s;//comanda
  PORTD=0x10;  //100
  for(temp_g=0;temp_g<50;temp_g++);//temporizare
  //temp();
}

void send_char (const char s)
{   
  int t;
  //temp();
  WritePortD(0x00,0x70);  //000
  SetPortA_Out(0xFF);//setare port A iesire
  SetPortD_Out(0x70);//setare port G iesire  

  WritePortA(s,0xFF);//data
  WritePortD(0x50,0x70);  //101 scriere data   
  
  for(t=0;t<50;t++);//temporizare
  temp(); 
}

void init()
{
//init_LCD();
  int temp_g;
  int ig;
  //initializare lcd
  DDRA=0xFF;//setare port A iesire
  DDRD=0xFF;//setare port G iesire
  //MA_WritePort_IO(MA_PORTG,0x00,0x07);  //000

  PORTD=0x10; //E=1 enable
  for(temp_g=0;temp_g<200;temp_g++);//temporizare

  //temp();
  for(ig=0;ig<3;ig++)
  {
   send_command(0x3c);//function Set : 8bits 2line on
   for(temp_g=0;temp_g<200;temp_g++);//temporizare
  }
   send_command(0x0F);//Display on
   for(temp_g=0;temp_g<200;temp_g++);//temporizare

   send_command(0x01);//Display clear
   for(temp_g=0;temp_g<200;temp_g++);//temporizare

   send_command(0x06);//Entry mode select
   for(temp_g=0;temp_g<200;temp_g++);//temporizare

 //  MA_WritePort_IO(MA_PORTE,0xFF,0xFF);//data

  // send_command(0x0f);//Display on
   //for(temp_g=0;temp_g<200;temp_g++);//temporizare
//End initializare
}   

void send_string (char *str) {			// sends the whole string to LCD
 while ((*str != 0)&& (*str != 10))
   send_char (*str++);
}

void setpos (char x,char y) {
 send_command (screenpos[x-1][y-1]);
}  
